;---------------------------------------
;newplayer v20.g4 packer v1.2
;(c) 1994 by huseyin 'wisdom' kilic.
;main packer routine was made in 940311,
;additions was made in 941016.
;v1.1 additions was made in 970422.
;v1.2 additions and 64tass compatibility
;were done in 20130723/24/27.
;---------------------------------------
;memory map:
;0810-0f00  object code
;0fa0-1000  pointers
;1000-cb00  music routine + song data
;cb00-cc00  should be kept empty
;cc00-d000  object code (the remaining)
;---------------------------------------
inpbuf   = $0340
tabl     = $0fa0
tabh     = $0fa1
topmem   = $cc00

n0       = $f7
n1       = $f8
n2       = $f9
n3       = $fa
n4       = $fb
n5       = $fc
n6       = $fd
n7       = $fe
e0       = $a6
e1       = $a7
temp1    = $a8
temp2    = $a9
temp3    = $aa
temp4    = $ab
temp5    = $ac
temp6    = $ad
temp7    = $ae
temp8    = $af

         *= $0801
;---------------------------------------
         .byte $0e,$08,$ca,$07,$9e,$32
         .byte $30,$36,$34,$57,$44,$4d
         .byte $00,$00,$00
;---------------------------------------
         ldx #<topmemcodebase
         ldy #>topmemcodebase
         stx n0
         sty n1
         ldx #<topmem
         ldy #>topmem
         stx n2
         sty n3
         ldx #4
         ldy #$00
movl1
         lda (n0),y
         sta (n2),y
         iny 
         bne movl1
         inc n1
         inc n3
         dex 
         bne movl1
;--------
         jsr $ff81
         jsr $ff84
         lda #$00
         jsr $ff90
main
         jsr setupscr
         ldx #$00
         ldy #$0f
         jsr load
         jsr checkplr
         bcs main        ;not newplrfile
         lda #<packmess
         ldy #>packmess
         jsr $ab1e

         sei
         lda #$36
         sta $01
         jsr pack
         jsr restore
         lda #$37
         sta $01
         cli

         jsr writelength
         jsr entertext
         lda #$00
         jsr $1000
         ldx #$00
         ldy #$10
         stx e0
         sty e1
         lda #e0
         ldx end
         ldy end+1
         jsr save
         jmp main
packmess
         .byte k_return
         .text "Packing..."
         .byte k_return
         .byte 0
;---------------------------------------
setupscr
         lda #$00
         sta $d011
         sta $d020
         sta $d021
         lda #<mainmess
         ldy #>mainmess
         jsr $ab1e
         lda #$63
         ldx #$27
supl1
         sta $0450,x
         dex
         bpl supl1
         lda #$08
         jsr $ffd2
         lda #$16
         sta $d018
         lda #$1b
         sta $d011
         rts
mainmess
         .byte k_ltblue,k_clear
         .text "      NewPlayer V20.G4 "
         .text "Packer V1.2"
         .byte k_return
         .text "  Programmed by Husey"
         .text "in 'WISDOM' Kilic"
         .byte k_return,k_return
         .byte 0
;---------------------------------------
load
         stx ladstl+1    ;load address.
         sty ladsth+1
         lda #$0e
         sta ladlen+1
ladj3
         ldx #$00
ladl0
         lda loadmess,x
         jsr $ffd2
         inx
ladlen   cpx #$aa
         bne ladl0
ladj2
         lda #$10
         jsr input
         cmp #$24
         bne ladj1
         jsr directory
         jsr setupscr
         lda #$0e
         sta ladlen+1
         jmp ladj3
ladj1
         cpx #$00
         beq ladj2
         lda #$0d
         jsr $ffd2
         lda #$01
         ldx #$08
         ldy #$00
         jsr $ffba
         lda inplen
         ldx #<inpbuf
         ldy #>inpbuf
         jsr $ffbd
         lda #$00
ladstl   ldx #$aa
ladsth   ldy #$aa
         jsr $ffd5
         bcc ladj4
         lda #k_up
         jsr $ffd2
         lda #$0c
         sta ladlen+1
         jmp ladj3
ladj4
         stx loadend
         sty loadend+1
         rts
loadmess
         .text "Load name  :$"
         .byte k_left
loadend  .word $ffff
;---------------------------------------
save
         sta svezpadr+1  ;zeropage adr.
         stx sveenl+1    ;save end.
         sty sveenh+1
         lda #$0d
         jsr $ffd2
         jsr $ffd2
svej3
         lda #<savemess
         ldy #>savemess
         jsr $ab1e
svej2
         lda #$10
         jsr input
         cmp #$24
         bne svej1
         jsr directory
         jsr $e544
         jmp svej3
svej1
         cpx #$00
         beq svej2
         lda #$0d
         jsr $ffd2
         lda #$01
         ldx #$08
         ldy #$00
         jsr $ffba
         lda #"@"
         sta inpbuf-2
         lda #":"
         sta inpbuf-1
         lda inplen
         clc
         adc #$02
         ldx #<inpbuf-2
         ldy #>inpbuf-2
         jsr $ffbd
svezpadr lda #$aa
sveenl   ldx #$aa
sveenh   ldy #$aa
         jsr $ffd8
         rts
savemess
         .text "Save name @:$"
         .byte k_left
         .byte 0
;---------------------------------------
input
         sta inputlen+1
         ldx #$00
inpl1    jsr $ffcf
         cmp #$0d
         beq inpj1
         sta inpbuf,x
         inx
inputlen cpx #$aa
         bne inpl1
inpj1
         stx inplen
         lda inpbuf
         rts
inplen
         .byte $00
;---------------------------------------
directory
         jsr $e544
         lda #$24
         ldx #$08
         ldy #$00
         jsr $ffba
         lda #$01
         ldx #<dirname
         ldy #>dirname
         jsr $ffbd
         jsr $ffc0
         ldx #$24
         jsr $ffc6
         clc
         ldy #$06
         ldx #$00
         jsr $fff0
         ldy #$04
dirl1
         jsr $ffcf
         dey
         bne dirl1
         jsr $ffcf
         tax
         jsr $ffcf
         jsr $bdcd
         lda #$20
dirl2
         jsr $ffd2
         jsr $ffcf
         bne dirl2
dirl3
         lda #$0d
         jsr $ffd2
         lda $c5
         cmp #$3f
         beq dirj2
         jsr $ffcf
         jsr $ffcf
         sec
         jsr $fff0
         clc
         ldy #$06
         jsr $fff0
         jsr $ffcf
         tax
         jsr $ffcf
         jsr $bdcd
dirl4
         jsr $ffcf
         cmp #$42
         beq dirj1
         cmp #$20
         beq dirl4
         pha
         sec
         jsr $fff0
         clc
         ldy #$0b
         jsr $fff0
         pla
dirl5
         jsr $ffd2
         jsr $ffcf
         beq dirl3
         bne dirl5
dirj1
         tax
         lda #$20
         jsr $ffd2
         txa
dirl6
         jsr $ffd2
         jsr $ffcf
         bne dirl6

         lda #$0d
         jsr $ffd2
dirj2
         lda #$24
         jsr $ffc3
         jsr $ffcc
         lda #<dirmess
         ldy #>dirmess
         jsr $ab1e
         lda #$00
         sta $c6
         jsr $ffe4
         beq *-3
         rts
dirname
         .text "$"
dirmess
         .byte k_right,k_right
         .byte k_right,k_right
         .byte k_right,k_right
         .byte k_right,k_right
         .byte k_right,k_right
         .byte k_right
         .byte k_rvson
         .text "  Press any key!  "
         .byte k_rvsoff
         .byte 0
;---------------------------------------
checkplr
         ldx loadend
         ldy loadend+1
         stx e0
         sty e1
         ldy #$00
         tya
chpl0
         sta (e0),y
         iny
         bne chpl0

         ldx #<tabl+$4e
         ldy #>tabl+$4e
         stx e0
         sty e1
         ldy #$04
chpl1
         lda (e0),y
         cmp version,y
         bne error
         dey
         bpl chpl1
         clc
         rts
error
         lda #<errmess1
         ldy #>errmess1
         jsr $ab1e
         lda #<version
         ldy #>version
         jsr $ab1e
         lda #<errmess2
         ldy #>errmess2
         jsr $ab1e
         jsr $ffe4
         beq *-3
         lda #$00
         sta $c6
         sec
         rts
errmess1
         .byte k_return
         .byte k_ltred
         .text "This is not a New"
         .text "Player v"
         .byte 0
version
         .text "20.g4"   ;**************
         .byte 0
errmess2
         .text " file."
         .byte k_return,k_return
         .byte k_ltblue
         .text "Press any key."
         .byte 0
;---------------------------------------
writelength
         lda #<lenmess1
         ldy #>lenmess1
         jsr $ab1e
         lda end+1
         sec
         sbc #$10
         jsr hexasc
         txa
         jsr $ffd2
         tya
         jsr $ffd2
         lda end
         jsr hexasc
         txa
         jsr $ffd2
         tya
         jsr $ffd2
         lda #<lenmess2
         ldy #>lenmess2
         jsr $ab1e
         rts
lenmess1
         .text "New length is $"
         .byte 0
lenmess2
         .text " bytes."
         .byte k_return
         .byte 0
;---------------------------------------
hexasc
         tay             ;a=hex value.
         and #$f0
         lsr a
         lsr a
         lsr a
         lsr a
         jsr convertasc
         tax
         tya
         and #$0f
         jsr convertasc
         tay
         rts             ;x=left nibble
                         ;y=right nibble
convertasc
         cmp #$0a
         bcc cvaj1
         clc
         adc #$37
         rts
cvaj1
         clc
         adc #$30
         rts
;---------------------------------------
entertext
         lda #<entmess
         ldy #>entmess
         jsr $ab1e
         ldx #$00
etxl1
         lda $1021,x
         jsr $ffd2
         inx
         cpx #$20
         bne etxl1
         sec
         jsr $fff0
         clc
         ldy #$00
         jsr $fff0
         lda #$20
         jsr input
         ldx #$1f
etxl2
         lda inpbuf,x
         sta $1020,x
         dex
         bpl etxl2
         rts
entmess
         .byte k_return
         .text "Enter player "
         .text "message:"
         .byte k_return
         .text "-"
         .byte 0
;---------------------------------------
pack
         ldx tabl+$06
         ldy tabh+$06
         stx n4
         sty n5

         ldx tabl+$1c
         ldy tabh+$1c
         stx n2
         sty n3

         clc
         lda tabl+$06
         adc #$10
         sta n0
         tax
         lda tabh+$06
         adc #$00
         sta n1

         stx trans
         sta trans+1
         ldy #$00
         jsr copytable   ;copy transpose

         stx wave
         sta wave+1
         ldy #$ff
         jsr copytable   ;copy waveforms

         stx filter
         sta filter+1
         ldy #$02
         jsr copytable   ;copy filter v.

         stx pulse
         sta pulse+1
         ldy #$02
         jsr copytable   ;copy pulse v.

         stx instr
         sta instr+1
         ldy #$03
         jsr copytable   ;copy sounds

         stx glide
         sta glide+1
         ldx tabl+$30
         ldy tabh+$30
         stx n2
         sty n3
         ldy #$01
         jsr copytable   ;copy glidelist
;--------
         ldy #$01        ;reset trkptr1
         sta (n4),y
         dey
         txa
         sta (n4),y
         ldx tabl+$26
         ldy tabh+$26
         jsr copytrack   ;pack&copy trk1

         ldy #$03        ;reset trkptr2
         sta (n4),y
         dey
         txa
         sta (n4),y
         ldx tabl+$28
         ldy tabh+$28
         jsr copytrack   ;pack&copy trk2

         ldy #$05        ;reset trkptr3
         sta (n4),y
         dey
         txa
         sta (n4),y
         ldx tabl+$2a
         ldy tabh+$2a
         jsr copytrack   ;pack&copy trk3

         stx blockl
         sta blockl+1

         clc
         lda n4
         adc #$08
         sta n6
         lda n5
         adc #$00
         sta n7
         ldy #$00
pl0      lda (n4),y      ;copying track
         sta (n6),y      ;pointers...
         iny
         cpy #$06
         bne pl0
         lda #$ff
         sta (n6),y      ;last two byte.
         iny
         sta (n6),y
;--------
         clc
         lda tabl+$32
         adc #$04
         sta n2
         lda tabh+$32
         adc #$00
         sta n3
         tax

         ldy #$00
         sty temp1
pl1      lda (n2),y      ;counting no.of
         beq pj1         ;blocks...
         inc temp1
         inc n3
         lda n3
         cmp #>topmem    ;top memory
         bne pl1
pj1
         stx n3
         clc
         lda blockl
         adc temp1
         sta blockh
         lda blockl+1
         adc #$00
         sta blockh+1

         clc
         lda blockh
         adc temp1
         sta n0
         lda blockh+1
         adc #$00
         sta n1

         ldx blockl
         ldy blockl+1
         stx n4
         sty n5
         ldx blockh
         ldy blockh+1
         stx n6
         sty n7


         ldx n0
         lda n1
         stx store+1
         sta store+2
         ldy #$00

pl2      sta (n6),y
         txa
         sta (n4),y
         sty temp2
         jsr copyblock   ;pack&copy blk.
         inc n3
         ldy temp2
         iny
         cpy temp1
         bne pl2
         stx end
         sta end+1
         rts
;---------------------------------------
copytable
         cpy #$ff        ;copy same
         beq cmj2        ;no. of bytes?

         sty temp2
         ldy #$ff        ;searching for
cml1     lda (n2),y      ;the end.
         bne cmj1
         dey
         bne cml1
cmj1
         sty temp1
         ldy temp2
         beq cmj2
         lda temp1
         cmp andtab,y    ;table full?
         bcc cmj15
         lda #$ff
         sta temp1
         bne cmj2
cmj15
         and chktab,y
         beq cmj2
         clc
         lda temp1
         adc addtab,y
         and andtab,y
         sta temp1
         dec temp1
cmj2
         ldy temp1
cml2     lda (n2),y      ;copying...
         sta (n0),y
         dec $d020
         inc $d020
         dey
         cpy #$ff
         bne cml2
         clc
         lda n0
         adc temp1
         sta n0
         lda n1
         adc #$00
         sta n1
         inc n0
         bne *+4
         inc n1
         ldx n0
         lda n1
         inc n3          ;next page.
         rts
chktab
         .byte $ff,$01,$03,$07
addtab
         .byte $ff,$02,$04,$08
andtab
         .byte $ff,$fe,$fc,$f8
;---------------------------------------
copytrack
         stx n2
         sty n3
         lda #$00
         sta temp1

         ldy #$00
ctl1     lda (n2),y
         bpl ctj1
         cmp temp1
         beq ctj3
         sta temp1
         sta (n0),y      ;store transp.
         cmp #$ff
         beq ctexit
         jmp ctj2
ctj1
         sta (n0),y      ;store block no
ctj2
         inc n0
         bne *+4
         inc n1
         dec $d020
         inc $d020
ctj3
         inc n2
         bne *+4
         inc n3
         jmp ctl1
ctexit
         inc n0
         bne *+4
         inc n1
         ldx n0
         lda n1
         rts
;---------------------------------------
;---------------------------------------
;---------------------------------------
topmemcodebase
         *= topmem
         .offs topmemcodebase-*
;---------------------------------------
;---------------------------------------
;---------------------------------------
copyblock
         lda #$ff
         sta temp3       ;for duration.
         sta temp7       ;for ins.
         lda #$00
         sta temp8       ;for s00 cmds.

         ldy #$00
cbl1     lda (n2),y
         bne cbj1
         jsr count
         beq cbja
         sta temp3
         ora #$80
         jsr store
cbja
         lda #$00
         jsr store
         jmp cbl1

cbj1
         cmp #$7e
         bne cbj2
         jsr count
         beq cbjb
         sta temp3
         ora #$80
         jsr store
cbjb
         lda #$7e
         jsr store
         jmp cbl1

cbj2
         cmp #$7f
         bcc cbj00
         jmp cbj4
cbj00
         tax
         lda temp3
         cmp #$90
         bne cbj0a
         lda #$ff
         sta temp3
         txa
         jsr store
         jmp cbinc
cbj0a
         iny
         lda (n2),y
         dey
         cmp #$80
         bne cbje
         iny
         iny
         lda (n2),y
         dey
         dey
         cmp #$7e
         bne cbje

         iny
         iny
         jsr count
         clc
         adc #$01
         cmp #$10
         bne cbj3
         lda #$0f
         cmp temp3
         beq cbjc
         sta temp3
         ora #$80
         jsr store
cbjc
         txa
         jsr store
         dey
         dey
         jmp cbl1

cbj3
         cmp temp3
         beq cbjd
         sta temp3
         ora #$80
         jsr store
cbjd
         txa
         jsr store
         jmp cbl1

cbje
         lda #$00
         cmp temp3
         beq cbjf
         sta temp3
         ora #$80
         jsr store
cbjf
         txa
         jsr store
         jmp cbinc
;--------
cbj4
         cmp #$80
         beq cbinc
         cmp #$7f
         beq cbexit
         cmp #$90
         bne cbj5
         jsr store
         lda #$90
         sta temp3
         jmp cbinc

cbj5
         cmp #$c0
         bcc cbj6
         jsr store
         lda #$01        ;set s00 flag
         sta temp8
         jmp cbinc
cbj6
         cmp temp7       ;same as last
         bne cbj7        ;used i00?
         lsr temp8       ;yes, check if
         bcc cbinc       ;a s00 used in
cbj7                     ;between 2 i00s
         sta temp7
         jsr store
         lda #$00        ;reset s00 flag
         sta temp8

cbinc
         iny
         jmp cbl1
cbexit
         lda #$7f
         jsr store
         ldx store+1
         lda store+2
         rts
;---------------------------------------
count
         sta temp6
         lda #$ff
         sta temp5
cl1      inc temp5
         iny
         lda (n2),y
         cmp #$80
         bne cj1
         iny
         lda temp5
         cmp #$0f
         beq cj1
         lda (n2),y
         cmp temp6
         beq cl1
cj1
         lda temp5
         cmp temp3
         rts
;---------------------------------------
store
         sta $ffff
         inc store+1
         bne *+5
         inc store+2
         dec $d020
         inc $d020
         rts
;---------------------------------------
restore
         ldx trans
         ldy trans+1
         stx temp1
         sty temp2
         ldx #$ae
         ldy #$14
         jsr wn
         ldx #$c7
         jsr wn
         ldx #$d8
         jsr wn
         ldx #$f3
         jsr wn
;--------
         ldx wave
         ldy wave+1
         stx temp1
         sty temp2
         ldx #$c0
         ldy #$14
         jsr wn
         ldx #$ec
         jsr wn
         ldx #$22
         ldy #$15
         jsr wn
;--------

         ldx filter
         ldy filter+1
         stx temp1
         sty temp2
         ldx #$da
         ldy #$10
         jsr wn
         ldx #$cc
         ldy #$13
         jsr wn
         ldx #$8a
         ldy #$14
         jsr wn

         clc
         lda filter
         adc #$01
         sta temp1
         lda filter+1
         adc #$00
         sta temp2
         ldx #$9b
         ldy #$14
         jsr wn

         clc
         lda filter
         adc #$02
         sta temp1
         lda filter+1
         adc #$00
         sta temp2
         ldx #$d6
         ldy #$13
         jsr wn
         ldx #$84
         ldy #$14
         jsr wn

         clc
         lda filter
         adc #$03
         sta temp1
         lda filter+1
         adc #$00
         sta temp2
         ldx #$6d
         ldy #$14
         jsr wn
         ldx #$7d
         jsr wn
;--------
         ldx pulse
         ldy pulse+1
         stx temp1
         sty temp2
         ldx #$5d
         ldy #$13
         jsr wn
         ldx #$28
         ldy #$14
         jsr wn

         clc
         lda pulse
         adc #$01
         sta temp1
         lda pulse+1
         adc #$00
         sta temp2
         ldx #$47
         ldy #$14
         jsr wn
         ldx #$5c
         jsr wn

         clc
         lda pulse
         adc #$02
         sta temp1
         lda pulse+1
         adc #$00
         sta temp2
         ldx #$70
         ldy #$13
         jsr wn
         ldx #$19
         ldy #$14
         jsr wn

         clc
         lda pulse
         adc #$03
         sta temp1
         lda pulse+1
         adc #$00
         sta temp2
         ldx #$12
         ldy #$14
         jsr wn
;--------
         ldx instr
         ldy instr+1
         stx temp1
         sty temp2
         ldx #$df
         ldy #$13
         jsr wn

         clc
         lda instr
         adc #$01
         sta temp1
         lda instr+1
         adc #$00
         sta temp2
         ldx #$38
         ldy #$12
         jsr wn
         ldx #$35
         ldy #$13
         jsr wn
         ldx #$ee
         jsr wn

         clc
         lda instr
         adc #$02
         sta temp1
         lda instr+1
         adc #$00
         sta temp2
         ldx #$44
         ldy #$13
         jsr wn
         ldx #$a4
         ldy #$14
         jsr wn

         clc
         lda instr
         adc #$03
         sta temp1
         lda instr+1
         adc #$00
         sta temp2
         ldx #$82
         ldy #$13
         jsr wn

         clc
         lda instr
         adc #$04
         sta temp1
         lda instr+1
         adc #$00
         sta temp2
         ldx #$c5
         ldy #$13
         jsr wn

         clc
         lda instr
         adc #$05
         sta temp1
         lda instr+1
         adc #$00
         sta temp2
         ldx #$56
         ldy #$13
         jsr wn

         clc
         lda instr
         adc #$06
         sta temp1
         lda instr+1
         adc #$00
         sta temp2
         ldx #$88
         ldy #$11
         jsr wn
         ldx #$e7
         ldy #$12
         jsr wn
         ldx #$3e
         ldy #$13
         jsr wn

         clc
         lda instr
         adc #$07
         sta temp1
         lda instr+1
         adc #$00
         sta temp2
         ldx #$85
         ldy #$11
         jsr wn
         ldx #$ea
         ldy #$12
         jsr wn
;--------
         ldx glide
         ldy glide+1
         stx temp1
         sty temp2
         ldx #$ed
         ldy #$11
         jsr wn
         ldx #$49
         ldy #$12
         jsr wn
         ldx #$db
         jsr wn

         clc
         lda glide
         adc #$01
         sta temp1
         lda glide+1
         adc #$00
         sta temp2
         ldx #$f6
         ldy #$11
         jsr wn
         ldx #$64
         ldy #$12
         jsr wn
         ldx #$86
         jsr wn
         ldx #$b2
         jsr wn
         ldx #$bf
         jsr wn
         ldx #$cc
         jsr wn
         ldx #$d5
         jsr wn
;--------
         ldx blockl
         ldy blockl+1
         stx temp1
         sty temp2
         ldx #$34
         ldy #$11
         jsr wn

         ldx blockh
         ldy blockh+1
         stx temp1
         sty temp2
         ldx #$39
         ldy #$11
         jsr wn

         rts
;---------------------------------------
wn
         stx n0          ;write new addr
         sty n1
         ldy #$00
         lda temp1
         sta (n0),y
         iny
         lda temp2
         sta (n0),y
         ldy n1
         dec $d020
         inc $d020
         rts
;---------------------------------------
;pointers
;---------------------------------------
trans    .word 0
wave     .word 0
filter   .word 0
pulse    .word 0
instr    .word 0
glide    .word 0
blockl   .word 0
blockh   .word 0
end      .word 0
;---------------------------------------
;keyboard codes
;---------------------------------------
k_white         = 5
k_shiftcoff     = 8
k_shiftcon      = 9
k_return        = 13
k_lowercase     = 14
k_down          = 17
k_rvson         = 18
k_home          = 19
k_del           = 20
k_red           = 28
k_right         = 29
k_green         = 30
k_blue          = 31
k_orange        = 129
k_shiftreturn   = 141
k_uppercase     = 142
k_black         = 144
k_up            = 145
k_rvsoff        = 146
k_clear         = 147
k_inst          = 148
k_brown         = 149
k_ltred         = 150
k_grey1         = 151
k_grey2         = 152
k_ltgreen       = 153
k_ltblue        = 154
k_grey3         = 155
k_purple        = 156
k_left          = 157
k_yellow        = 158
k_cyan          = 159
;---------------------------------------
